appcan.define('model_ajax', function ($, exports, modules) {
    var MAS_SERVER_URL=serverIp2;
    
    //do something
    /**
     *异步服务调用
     */
    var ajaxServer = {
        /**
         *通过参数获取lockkey，唯一值
         */
        getLockey: function (string) {
            if (string) {
                //有option对象，把它变成字符串
                string=encodeURI(string);
                var md5 = appcan.crypto.md5(string);
                return md5;
            }
        },
        /**
         * ajax请求
         */
        ajax : function(ajaxOption) {
            var self = this;
            var lockKey = self.getLockey(JSON.stringify(ajaxOption.option));
            if (self[lockKey]) {
                //如果锁定请求的话，不再提交
                return;
            }
            //加请求锁
            self[lockKey] = true;
            //打开请求提示
            TOOLS.openToast('数据请求中', 0, 5, 0,false);
            //ajax请求变量
            var ajaxCall=appcan.request.ajax;
            if(isSML){
                //如果是模拟器的话，调用zepo的,便于调试
                ajaxCall=$.ajax
            }
            ajaxCall({
                url: ajaxOption.option.url,
                type: ajaxOption.option.type,
                timeout: 50000,
                data: ajaxOption.option.data,
                headers : self.getHeaders(), //获取mas请求头
                success: function (data) {
                    self[lockKey] = null;
                    //关闭请求提示
                    TOOLS.closeToast();
                    if (ajaxOption.success) {
                        if ( typeof (data) == "string") {
                            //如果是字符串的话，把他变为对象
                            if (data.substring(0, 1) == '{') {
                                try {
                                    data = JSON.parse(data);
                                    if(data.status==-999||data.status==14504){
                                        //门户失效
                                         appcan.window.publish('TOKENOUTOFFLOGIN','');
                                    }else{
                                         ajaxOption.success(data);
                                    }
                                } catch(e) {
                                    //appcan.window.openToast('返回数据不是json格式', 1200, 5, 0);
                                }
                            } else {
                                //返回的是html字符串
                                ajaxOption.success(data);
                            }
                        }else{
                            //json对象
                             ajaxOption.success(data);
                        }
                    } else {
                        //先进入通用的res提示
                        self.resTip(data, ajaxOption.cb);
                    }
                },
                error: function (e) {
                    self[lockKey] = null;
                    if (ajaxOption.error) {
                        ajaxOption.error(e);
                    } else {
                        self.errTip(e);
                    }
                }
            });
        },
        /**
         *加载模板返回
         */
        loadTemplate: function (template_path) {
            var template_url = HTML_BASE_URL + template_path;
            var template_body = '';
            //同步方法获取
            $.ajax({
                url: template_url,
                type: 'GET',
                data: {}, //默认从参数获取
                timeout: 30000,
                async: false,
                success: function (data) {
                    template_body = data;
                },
                error: function (e) {

                }
            });
            return template_body;
        },
        
        /**
         *构建模板对象
         ** @param {Object} template_html 模板的html或模板文件
         */
        buildTpl: function (template_html) {
            var self = this;

            /**
             *判断传入的参数是否为路径
             */
            function isPath(template_html) {
                var flag = false;
                var length = template_html.length;//获取文档长度
                //获取最后的5个字符，来判断
                var key = template_html.substring(length - 5);
                if (key.indexOf('.html') > -1||key.indexOf('.tpl') > -1) {
                    //说明最后结尾时.html的，是一个路径
                    flag = true;
                }
                return flag;
            }

            if (isPath(template_html)) {
                //说明时一个路径，就调用loadTemplate去获取文件
                template_html = self.loadTemplate(template_html);
            } else {
                //说明时文件，直接可以编译文档
            }
            var _ = appcan.require('underscore');
            //生成模板对象
            var _tmp = _.template(template_html);
            return _tmp;
        },
        
        /*
         *使用模板的方式输出
         * @param {Object} template_html 模板的html
         * @param {Object} data 模板要传入的值
         */
        template: function (template_html, data) {
            var _ = appcan.require('underscore');
            //生成模板对象
            var _tmp = _.template(template_html);
            //模板传入data值，输出html
            var html = _tmp(data);
            return html;
        },
        
        /**
         *获取mas服务的header
         */
        getHeaders: function () {
            if(getEmmToken()){
                //有值
                var sid=getEmmToken().info.accessToken;
                var emmObj = "/"+sid;
                return {
                    "x-mas-app-info": emmObj
                };
            }else{
                //没有值
                //TODO：
            }
        },
        
        /**
         *异常提示
         */
        errTip: function (e) {
            var self=this;
            //TOOLS.openToast('网络状态异常，请重试', 1200, 5, 0,false);
            self.doReEvent();//自动判断是否再次执行有异常的请求
            TOOLS.logs('网络状态异常，请重试' + JSON.stringify(e));
        },
        /**
         *自动判断是否再次执行有异常的请求
         */
        doReEvent:function(){
             var reEvent=TOOLS.store('RE_EVENT');
             if(reEvent){
                 //如果有定义异常就执行下
                appcan.window.alert({
                  title : "",
                  content : "网络状态异常,是否重试?",
                  buttons : ['否', '是'],
                  callback : function(err, data, dataType, optId) {
                      if(!err){
                          if(data==1){
                              //点击 了确定
                             TOOLS.removeStore('RE_EVENT');//执行前把事件再清空
                             eval(reEvent);//用eval函数来重新执行，这个其实不好
                          }else{
                              //点击了取消，啥也不做
                          }
                      }
                  }
                });
             }
        },
        /**
         *ajax恢复提示
         * @param {Object} data ajax返回的数据
         * @param {Object} callbackfun 回调函数
         */
        resTip: function (data, callbackfun) {
            var self = this;
            if (typeof (data) == "string") {
                //如果是字符串的话，把他变为对象
                if(data.substring(0,1)=="{"){
                    try{
                        data = JSON.parse(data);
                    }catch(e){
                       TOOLS.openToast('返回数据不是json格式', 1200, 5, 0,false);
                       return;
                    }
                }else{
                    //返回的是html字符串
                    callbackfun(data);
                    return;
                }
            }
            if (self.successCallbackfun) {
                //如果有定义成功的返回函数，就执行自定义的函数注入
                self.successCallbackfun(data);
                return;
            }
            if (data.status === 0) {
                //如果是正常的话
                if (callbackfun) {
                    callbackfun(data);
                }
            } else if (data.status && data.message) {
                //有错误代码，给予提示，不做callback返回
                TOOLS.openToast(data.message, 1200, 5, 0,false);
                //有错误代码，给予提示，不做callback返回
                if(data.status===-99){
                    //未登录
                    self.doReEvent();//自动判断是否再次执行有异常的请求
                    NAV.openReLogin();//打开重复登陆界面
                }else if(data.status===-999||data.status==14504){
                    //门户失效
                    appcan.window.publish('TOKENOUTOFFLOGIN','');
                }
            } else {
                //其他情况,做好callback返回
                TOOLS.openToast('未知异常', 1200, 5, 0,false);
            }
        },
        
        
        /**
         * 获取理赔申请人信息
         * @param {Object} data
         * @param {Object} cb
         */
        queryClaimsInfo: function (data, cb) {
            var self = this;
            self.ajax({
                option: {
                    type: 'get',
                    url: MAS_SERVER_URL + 'ajaxinvoke/claimService/queryClaimsInfo',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }
            });
        },
        
        /**
         * 获取个人基本信息
         * @param {Object} data
         * @param {Object} cb
         */
        getAccountInfo:function (data, cb) {
            var self = this;
            self.ajax({
                option: {
                    type: 'get',
                    url: MAS_SERVER_URL + 'ajaxinvoke/accountService/getAccountInfo',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }
            });
        },
        
        /**
         * 更新基本信息
         */
        updateAccountInfo: function (data, cb) {
            var self = this;
            self.ajax({
                option: {
                    type : 'POST',
                    url: MAS_SERVER_URL + 'ajaxinvoke/accountService/updateAccountInfo',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }
            });
        },
        
        /**
         * 保存理赔申请人信息
         */
        addClaimsApplication : function (data, cb) {
            var self = this;
            self.ajax({
                option: {
                    type : 'POST',
                    url: MAS_SERVER_URL + 'ajaxinvoke/claimService/addClaimsApplication',
                    data: data
                },
                success: function (addClaimData) {
                    //默认成功定处理返回信息
                    cb(addClaimData);
                }
            });
        },
        
        /**
         *理赔申请状态提交 
         */
        updateStatus : function(data, cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'get',
                    url: MAS_SERVER_URL + 'ajaxinvoke/claimService/updateStatus',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }
            });
        },
        
        /**
         *获取理赔材料接口
         */
        getMaterial : function(data, cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'get',
                    url: MAS_SERVER_URL + 'ajaxinvoke/claimService/getMaterial',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }
            });
        },
        
        /**
         *理赔材料上传
         */
        uploadMaterial : function(data, cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'POST',
                    url: MAS_SERVER_URL + 'ajaxinvoke/claimService/uploadMaterial',
                    data: data
                },
                success: function (materialdata) {
                    //默认成功定处理返回信息
                    cb(materialdata);
                }
            });
        },
        /*
         * 
         * 删除理赔材料
         * 
         */
        delMaterial: function(data,cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'get',
                    url: MAS_SERVER_URL + 'ajaxinvoke/claimService/delMaterial',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }                
            });            
        },
        /*
         *获取理赔列表数据
         * 
         */
        getClaimList: function(data , cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'get',
                    url: MAS_SERVER_URL + 'ajaxinvoke/claimService/getClaimList',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }                
            });
        },
        /*
         * 理赔再次申请
         */
        claimApplyed : function(data,cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'post',
                    url: MAS_SERVER_URL + 'ajaxinvoke/claimService/reClaimsApplication',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }                
            });            
        },
        /*
         * 获取银行信息列表
         * 
         */
        getBankList: function(data,cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'get',
                    url: MAS_SERVER_URL + 'ajaxinvoke/accountService/getBankInfo',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }                
            });             
        },
        /*
         * 
         * 保存银行信息
         */
        saveBankMsg: function(data,cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'post',
                    url: MAS_SERVER_URL + 'ajaxinvoke/accountService/updateAccountBankInfo',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }                
            });            
        },
        /*
         * 连带人管理页面获取连带人列表数据
         * 
         */
        getJointPeople: function(data,cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'get',
                    url: MAS_SERVER_URL + 'ajaxinvoke/accountService/getAssociatedPersion',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }                
            });             
        },
        /*
         * 
         * 删除连带人接口
         */
        delAssociatedPersion: function(data,cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'post',
                    url: MAS_SERVER_URL + 'ajaxinvoke/accountService/delAssociatedPersion',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }                
            });
        },
        /*
         * 连带人信息保存
         * 
         */
        addAssociatedPersion:function(data,cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'post',
                    url: MAS_SERVER_URL + 'ajaxinvoke/accountService/addAssociatedPersion',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }              
            }); 
        },
        /*
         * 
         * 图片上传接口
         */
        uploadImages: function(data,cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'post',
                    url: MAS_SERVER_URL + 'ajaxinvoke/accountService/uploadImages',
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }                
            });            
        },
        /*
         * 
         * 验证个人身份证
         */
        checkIdCard: function(data,cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'GET',
                    url: serverIp + "ajaxinvoke/hiresepService/checkIdc",
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }                
            });            
        },
        
        /**
         * 删除材料
         */
        delMaterial: function(data,cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'post',
                    url: MAS_SERVER_URL + "ajaxinvoke/claimService/delMaterial",
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }                
            });            
        },
        /*
         * 获取理赔详情
         */
        getClaimInfo: function(data,cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'get',
                    url: MAS_SERVER_URL + "ajaxinvoke/claimService/getClaimInfo",
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }                 
            })
        },
        /*
         * 
         * 上传证件中的结婚证，出生证
         */
        bindAssociatedPhoto: function(data,cb){
            var self = this;
            self.ajax({
                option: {
                    type : 'post',
                    url: MAS_SERVER_URL + "ajaxinvoke/claimService/bindAssociatedPhoto",
                    data: data
                },
                success: function (ajaxdata) {
                    //默认成功定处理返回信息
                    cb(ajaxdata);
                }                 
            })            
        }
        
    }
    modules.exports = ajaxServer;
});
